; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD

      qisort    PROTO :DWORD,:DWORD,:DWORD
      quicksort PROTO :DWORD,:DWORD,:DWORD
      isort     PROTO :DWORD,:DWORD,:DWORD
      split     PROTO :DWORD,:DWORD,:DWORD
      ssort     PROTO :DWORD,:DWORD,:DWORD

    ; -----------------------------
    ; macros for displaying results
    ; -----------------------------
      SBtext MACRO part,lpString
        invoke SendMessage,hStatus,SB_SETTEXT,part-1,reparg(lpString)
      ENDM

      TBtext MACRO lpString
        invoke SetWindowText,FUNC(GetActiveWindow),reparg(lpString)
      ENDM

      EDtext MACRO lpString
        invoke SetWindowText,hEdit,reparg(lpString)
      ENDM

      EDclear equ <EDtext 0>

    .data?
        hWnd      dd ?
        hInstance dd ?
        hStatus   dd ?
        hEdit     dd ?
        rcnt      dd ?

    .code

    memsize equ <2500000>


; 

start: 
    mov hInstance, FUNC(GetModuleHandle,NULL)
    call main
    invoke ExitProcess,eax

; 

main proc

    invoke InitCommonControls

    Dialog "   ", \                         ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            9, \                            ; number of controls
            50,50,250,106, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Test quicksort",WS_TABSTOP,5, 5,50,13,101
    DlgButton "Time quicksort",WS_TABSTOP,5,20,50,13,102
    DlgButton "Time qisort",WS_TABSTOP,5,35,50,13,103
    DlgButton "Test 4",WS_TABSTOP,5,50,50,13,104
    DlgButton "Test 5",WS_TABSTOP,5,65,50,13,105
    DlgButton "Reset",WS_TABSTOP,60,65,50,13,106
    DlgButton "Close",WS_TABSTOP,192,65,50,13,IDCANCEL
    DlgStatus 110
    DlgEdit WS_TABSTOP or ES_MULTILINE or ES_WANTRETURN or \
            ES_LEFT or WS_BORDER or WS_VSCROLL,60,5,182,58,111

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

align 4

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL hDC   :DWORD
    LOCAL pstr  :DWORD
    LOCAL hMem  :DWORD
    LOCAL ps    :PAINTSTRUCT 
    LOCAL rct   :RECT 
    LOCAL crct  :RECT 
    LOCAL buffer1[260]:BYTE 
    LOCAL buffer2[260]:BYTE 
    LOCAL buffer3[260]:BYTE 
    LOCAL buffer4[260]:BYTE 

    STRING MainTitle,"Hybrid Quick/Insertion Sort"

    Switch uMsg
      Case WM_INITDIALOG
        m2m hWnd, hWin
        invoke SendMessage,hWnd,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        invoke SetWindowText,hWnd,ADDR MainTitle

        mov hStatus, FUNC(GetDlgItem,hWnd,110)
        GLOBAL sbarray dd 100,200,300,400,-1
        invoke SendMessage,hStatus,SB_SETPARTS,5,ADDR sbarray

        mov hEdit,   FUNC(GetDlgItem,hWnd,111)
        invoke SendMessage,hEdit,WM_SETFONT,
                           FUNC(GetStockObject,ANSI_FIXED_FONT),TRUE
        mov eax, 1

      Case WM_COMMAND
        Switch wParam
          Case 101
          ; ******************************************************

            .data
              buffr dd 48,47,46,45,44,43,42,41,40,39,38,37,36,35,34,33,32,31,30,29,28,27,26,
                       25,24,23,22,21,20,19,18,17,16,15,14,13,12,11,10,9,8,7,6,5,4,3,2,1


              ;; buffr dd 17,17,16,16,15,15,14,14,13,13,12,12,11,11,10,10,9,9,8,8,7,7,6,6,5,5,4,4,3,3,2,2,1,1
              ;; buffr dd 9,8,7,6,5,4,3,2,1,0
              ;; buffr dd 1,20,19,2,18,3,17,4,16,5,15,6,14,7,13,8,12,9,11,10,12,9,13,8,14,7,15,6,16,5,17,4,18,3,19,2,20,1
              ;; buffr dd 1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1
              ;; buffr dd 20,1,4,13,5,19,7,8,11,15,10,12,14,18,3,9,17,6,16,2

              ;; junk dd 512 dup (0)

              array dd LENGTHOF buffr dup (0)
            .code

            push esi
            push edi

            mov ecx, LENGTHOF buffr
            mov esi, OFFSET buffr
            mov edi, OFFSET array
            rep movsd

            mov esi, OFFSET array

          ; ==========================

            invoke qisort,OFFSET array,0,LENGTHOF buffr

            ;; invoke quicksort,OFFSET array,0,LENGTHOF buffr

          ; ==========================

            mov esi, OFFSET array
            mov pstr, ptr$(buffer1)

            mov edi, LENGTHOF array
          @@:
            mov pstr, cat$(pstr,str$([esi]))
            add esi, 4
            sub edi, 1
            jz @F
            mov pstr, cat$(pstr,".")
            jmp @B
          @@:

            EDtext pstr

            pop edi
            pop esi

          ; ******************************************************

          Case 102

            mov rcnt, 0

            invoke nseed, 87654321

            mov hMem, alloc(memsize*4)

            push esi
            push edi

            mov esi, memsize
            mov edi, hMem
          @@:
            invoke nrandom, 5000000
            mov [edi], eax
            add edi, 4
            sub esi, 1
            jnz @B

            pop edi
            pop esi

            invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

            invoke GetTickCount
            push eax

          ; ==========================

            invoke quicksort,hMem,0,memsize

          ; ==========================

            invoke GetTickCount
            pop ecx
            sub eax, ecx

            fn MessageBox,hWnd,str$(eax),"quicksort",MB_OK

            free hMem

            invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

          Case 103

            mov rcnt, 0

            invoke nseed, 87654321

            mov hMem, alloc(memsize*4)

            push esi
            push edi

            mov esi, memsize
            mov edi, hMem
          @@:
            invoke nrandom, 5000000
            mov [edi], eax
            add edi, 4
            sub esi, 1
            jnz @B

            pop edi
            pop esi

            invoke SetPriorityClass,FUNC(GetCurrentProcess),REALTIME_PRIORITY_CLASS

            invoke GetTickCount
            push eax

          ; ==========================

            invoke qisort,hMem,0,memsize

          ; ==========================

            invoke GetTickCount
            pop ecx
            sub eax, ecx

            fn MessageBox,hWnd,str$(eax),"qisort",MB_OK

            free hMem

            invoke SetPriorityClass,FUNC(GetCurrentProcess),NORMAL_PRIORITY_CLASS

          Case 104
            TBtext "ID 104"
            SBtext 4,"Test 4"
            EDtext "The 4th button was pressed"

          Case 105
            TBtext "ID 105"
            SBtext 5,"Test 5"
            EDtext "OK, you pressed button 5"

          Case 106
            EDclear
            SBtext 1,0
            SBtext 2,0
            SBtext 3,0
            SBtext 4,0
            SBtext 5,0
            TBtext ADDR MainTitle

          Case IDCANCEL
            jmp quit_dialog
        Endsw

      Case WM_PAINT
        mov hDC, FUNC(BeginPaint,hWin,ADDR ps)
        invoke GetClientRect,hWin,ADDR rct
        invoke GetWindowRect,hStatus,ADDR crct
        mov eax, crct.bottom
        sub eax, crct.top
        sub rct.bottom, eax
        invoke DrawEdge,hDC,ADDR rct,EDGE_ETCHED,BF_RECT
        invoke EndPaint,hWin,ADDR ps

      Case WM_CLOSE
        quit_dialog: 
        invoke EndDialog,hWin,0
    Endsw

    xor eax, eax
    ret

DlgProc endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

isort proc arr:DWORD,lower:DWORD,upper:DWORD

    mov [esp-8], ebx
    mov [esp-12], esi
    mov [esp-16], edi

    mov eax, [esp+8]    ; lower
    shl eax, 2
    mov ebx, [esp+4]    ; arr
    add ebx, eax

    mov eax, [esp+12]   ; upper
    sub eax, [esp+8]    ; lower

    mov edi, 1
    cmp edi, eax
    jge quit
    jmp istart

  align 4
; ====================================
  insert:
    mov [ebx+ecx*4], esi
    add edi, 1
    cmp edi, eax
    jge quit
  istart:
    mov esi, [ebx+edi*4]
    mov ecx, edi
  inner:
    mov edx, [ebx+ecx*4-4]
    cmp edx, esi
    jle insert
    mov [ebx+ecx*4], edx
    sub ecx, 1
    jnz inner
    jmp insert
  quit:
; ====================================


    mov ebx, [esp-8]
    mov esi, [esp-12]
    mov edi, [esp-16]
  
    ret 12
 
isort ENDP

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

align 4

qisort proc arr:DWORD,lower:DWORD,upper:DWORD

    mov eax, upper
    sub eax, lower

    cmp eax, 1
    jl @F

    cmp eax, 16
    jge partition
    invoke isort,arr,lower,upper
    ret

  partition:
    add lower, 1
    invoke split,arr,lower,upper
    push eax
    sub eax, 1
    invoke qisort,arr,lower,eax     ; lead
    pop eax
    sub upper, 1
    invoke qisort,arr,eax,upper     ; tail

  @@:

    ret

qisort endp

; 

quicksort proc arr:DWORD,lower:DWORD,upper:DWORD

    mov eax, upper
    cmp lower, eax
    jge @F

 ;     add lower, 1
 ;     invoke split,arr,lower,upper
 ;     push eax
 ;     sub eax, 1
 ;     invoke quicksort,arr,lower,eax     ; lead
 ;     pop eax
 ;     sub upper, 1
 ;     invoke quicksort,arr,eax,upper     ; tail

    add lower, 1
    invoke split,arr,lower,upper
    push eax
    sub eax, 1

    cmp lower, eax
    jge nxt1
    invoke quicksort,arr,lower,eax
  nxt1:
    pop eax
    sub upper, 1
    cmp eax, upper
    jge nxt2
    invoke quicksort,arr,eax,upper
  nxt2:

  @@:

    ret

quicksort endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

split proc arr:DWORD,lower:DWORD,upper:DWORD

    mov [esp-8], ebx
    mov [esp-12], esi
    mov [esp-16], edi
    mov [esp-20], ebp

    mov ebx, [esp+4]    ; arr
    sub ebx, 4
    mov eax, [esp+8]    ; lower
    mov edi, [esp+12]   ; upper
    mov esi, edi
    sub esi, 1

    cmp eax, esi
    jg quitsplit

    mov edx, [ebx+eax*4]        ; pivot from lower index
 ;     mov ecx, [ebx+edi*4]        ; pivot from upper index
 ; 
 ;     cmp edx, ecx
 ;     jl @F
 ;     mov edx, ecx
 ;   @@:


    sub eax, 1                  ; saves jumping into loop

; ============================

  lloop:
    add eax, 1                  ; increment split index
  backin:
    cmp [ebx+eax*4], edx
    jl lloop                    ; predicted backwards
    add esi, 1                  ; add allows fall through
  uloop:
    sub esi, 1                  ; decrement upper index
    cmp eax, esi                ; if split > upper
    jg lpout
    cmp [ebx+esi*4], edx
    jg uloop                    ; predicted backwards
    mov ecx, [ebx+eax*4]        ; swap values
    mov ebp, [ebx+edi*4]
    mov [ebx+edi*4], ecx
    mov [ebx+eax*4], ebp
    add eax, 1                  ; increment split index
    sub esi, 1                  ; decrement upper index
    cmp eax, esi                ; if split <= upper index loop again
    jle backin                  ; predicted backwards
  lpout:

; ============================

    mov ecx, [ebx+eax*4]
    mov ebp, [ebx+edi*4]
    mov [ebx+edi*4], ecx
    mov [ebx+eax*4], ebp

  ; return value in EAX is next split value

  quitsplit:

    mov ebx, [esp-8]
    mov esi, [esp-12]
    mov edi, [esp-16]
    mov ebp, [esp-20]

    ret 12

split endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

align 4

ssort proc arr:DWORD,lb:DWORD,ub:DWORD

  ; --------------
  ; selection sort
  ; --------------

    push ebx
    push esi
    push edi

    mov ebx, arr
    mov esi, lb

  cSt:
    mov ecx, esi
    mov edi, 7FFFFFFFh          ; LONG range

  clbl:
    cmp edi, [ebx+ecx*4]        ; cmp lowest value holder to current member
    jl cnxt
    mov edi, [ebx+ecx*4]        ; store value in EDI if smaller
    mov edx, ecx                ; store the index
  cnxt:
    add ecx, 1
    cmp ecx, ub
    jne clbl
    mov eax, [ebx+edx*4]        ; do the swap
    mov edi, [ebx+esi*4]
    mov [ebx+edx*4], edi
    mov [ebx+esi*4], eax
    add esi, 1
    cmp esi, ub
    jne cSt

    pop edi
    pop esi
    pop ebx

    ret

ssort endp

; 



 ;     .while eax <= esi
 ; 
 ;       .while [ebx+eax*4] < edx
 ;         inc eax
 ;       .endw
 ; 
 ;       .while esi >= eax && [ebx+esi*4] >= edx
 ;         dec esi
 ;       .endw
 ; 
 ;       .if eax <= esi
 ;         mov ecx, [ebx+eax*4]
 ;         mov ebp, [ebx+edi*4]
 ;         mov [ebx+edi*4], ecx
 ;         mov [ebx+eax*4], ebp
 ;         inc eax
 ;         dec esi
 ;       .endif
 ; 
 ;     .endw

; 

end start
